/*********************************************************************************************************
*
* File                : main.c
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM  Version: 4.20
* Version             : V1.0
* By                  : 
*
*                                  (c) Copyright 2005-2011, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "SysTick\\systick.h"
#include <stdio.h>
#include "USART\\usart.h"

/* Private define ------------------------------------------------------------*/
#define ADC1_DR_Address    ((u32)0x4001244C)

/* Private function prototypes -----------------------------------------------*/
void USART_Configuration(void);
void ADC_Configuration(void);

/* Private variables ---------------------------------------------------------*/
float AD_value;
vu16 ADC_ConvertedValue;

/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
int main(void)
{
	u8 sta;
	Delay_Init();
	USART_Configuration();
	ADC_Configuration();

  /* Infinite loop */
  while (1)
  {
    /* Printf message with AD value to serial port every 1 second */
	  AD_value = ADC_ConvertedValue;
	  AD_value = (AD_value/4096)*3.3;
//    printf("The current AD value = %4.4fV \r\n", AD_value);
		
		if((AD_value>=0)&&(AD_value<=0.1))
		{
			
			sta=1;
			printf("\r\n*************************************************\r\n");
			Delay(2000);		
		}
		while(sta)
		{

		  AD_value = ADC_ConvertedValue;
		  AD_value = (AD_value/4096)*3.3;

		if((AD_value>=0)&&(AD_value<=0.1))
		  printf("µİǣKEY0 \r\n");

		if((AD_value>=0.1)&&(AD_value<=0.3))
		  printf("µİǣKEY1 \r\n");

		if((AD_value>=0.3)&&(AD_value<=0.5))
		  printf("µİǣKEY2 \r\n");

		if((AD_value>=0.5)&&(AD_value<=0.7))
		  printf("µİǣKEY3 \r\n");

		if((AD_value>=0.7)&&(AD_value<=0.9))
		  printf("µİǣKEY4 \r\n");

		if((AD_value>=0.9)&&(AD_value<=1.1))
		  printf("µİǣKEY5 \r\n");

		if((AD_value>=1.1)&&(AD_value<=1.3))
		  printf("µİǣKEY6 \r\n");

		if((AD_value>=1.3)&&(AD_value<=1.5))
		  printf("µİǣKEY7 \r\n");

		if((AD_value>=1.5)&&(AD_value<=1.8))
		  printf("µİǣKEY8 \r\n");

		 if((AD_value>=1.8)&&(AD_value<=2.0))
		  printf("µİǣKEY9 \r\n");

		if((AD_value>=2.0)&&(AD_value<=2.2))
		  printf("µİǣKEY10 \r\n");

		if((AD_value>=2.2)&&(AD_value<=2.4))
		  printf("µİǣKEY11 \r\n");

		 if((AD_value>=2.4)&&(AD_value<=2.6))
		  printf("µİǣKEY12 \r\n");

		if((AD_value>=2.6)&&(AD_value<=2.8))
		  printf("µİǣKEY13 \r\n");

		if((AD_value>=2.8)&&(AD_value<=3.0))
		  printf("µİǣKEY14 \r\n");

		if((AD_value>=3.0)&&(AD_value<=3.2))
		  printf("µİǣKEY15 \r\n");
	  	Delay(150);   /* delay 1000ms */
	  }
	}
}

/*******************************************************************************
* Function Name  : ADC_Configuration
* Description    : Configure the ADC.
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void ADC_Configuration(void)
{
  ADC_InitTypeDef ADC_InitStructure;
  DMA_InitTypeDef DMA_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 | RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);

  /* Configure PA.06 (ADC Channel6), PA.07 (ADC Channel7) as analog input -------------------------*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_Init(GPIOA, &GPIO_InitStructure);   
   
  /* DMA channel1 configuration ----------------------------------------------*/
  DMA_DeInit(DMA1_Channel1);
  DMA_InitStructure.DMA_PeripheralBaseAddr = ADC1_DR_Address;
  DMA_InitStructure.DMA_MemoryBaseAddr = (u32)&ADC_ConvertedValue;
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
  DMA_InitStructure.DMA_BufferSize = 1;
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Disable;
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
  DMA_Init(DMA1_Channel1, &DMA_InitStructure);
  
  /* Enable DMA1 channel1 */
  DMA_Cmd(DMA1_Channel1, ENABLE);
    
  /* ADC1 configuration ------------------------------------------------------*/
  ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;
  ADC_InitStructure.ADC_ScanConvMode = ENABLE;
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
  ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  ADC_InitStructure.ADC_NbrOfChannel = 1;
  ADC_Init(ADC1, &ADC_InitStructure);

  /* ADC1 regular channel6 configuration */ 
  ADC_RegularChannelConfig(ADC1, ADC_Channel_0, 1, ADC_SampleTime_239Cycles5);

  /* Enable ADC1 DMA */
  ADC_DMACmd(ADC1, ENABLE);
  
  /* Enable ADC1 */
  ADC_Cmd(ADC1, ENABLE);

  /* Enable ADC1 reset calibaration register */   
  ADC_ResetCalibration(ADC1);
  /* Check the end of ADC1 reset calibration register */
  while(ADC_GetResetCalibrationStatus(ADC1));

  /* Start ADC1 calibaration */
  ADC_StartCalibration(ADC1);
  /* Check the end of ADC1 calibration */
  while(ADC_GetCalibrationStatus(ADC1));
     
  /* Start ADC1 Software Conversion */ 
  ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/
