#include "stm32f10x.h"
#include "User_systick.h"
#include "LTM022A69B.h"
#include "LCD_lib.h"

#include"touch.h"




#define TOUCH_nCS_H()    GPIO_SetBits(GPIOA,GPIO_Pin_15)
#define TOUCH_nCS_L()    GPIO_ResetBits(GPIOA,GPIO_Pin_15)


#define CMD_READ_X    0xD0  //0B11010000òַʽX
#define CMD_READ_Y    0x90  //0B10010000òַʽY

 typedef struct 
{
	unsigned int  x;//LCD
	unsigned int  y;
	unsigned long x_ad_val; //ADCֵ
	unsigned long y_ad_val;						   	    
	unsigned char  pen_status;//ʵ״̬			  
}_touch_dot;


_touch_dot touch_dot,*p_touch_dot;//



void TOUCH_init(void)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOB , ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOA , ENABLE);
  GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable,ENABLE);
	
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_15;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStruct);
	
	GPIO_SetBits(GPIOA,GPIO_Pin_15);
	
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStruct);
}


void TOUCH_WRITE_REG(unsigned int index)
{
	
	LCD_RS_L();
	TOUCH_nCS_L();

    SPI0_communication((unsigned char)(index>>8));    //00000000 000000000
    SPI0_communication((unsigned char)(index));

	TOUCH_nCS_H();
	LCD_RS_H();

}

/******************************************************************************
* Function Name  : LCD_WRITE_COMMAND
* Description    : send command to LCD
* Input          : index, data
* Output         : None
* Return         : None
******************************************************************************/
void TOUCH_WRITE_COMMAND(unsigned int index,unsigned int data)
{
	//select command register

	LCD_RS_L();
	TOUCH_nCS_L();

    SPI0_communication((unsigned char)(index>>8));    //00000000 000000000
    SPI0_communication((unsigned char)(index));
	LCD_CS_H();
	//send data
	LCD_RS_H();

	TOUCH_nCS_L();
    SPI0_communication((unsigned char)(data>>8));    //00000000 000000000
    SPI0_communication((unsigned char)(data));
	TOUCH_nCS_H();

}

/*******************************************************************************
* Function Name  : LCD_WRITE_DATA
* Description    : write data to LCD
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void TOUCH_WRITE_DATA(unsigned int data)
{
    SPI0_communication((unsigned char)(data>>8));    //00000000 000000000
    SPI0_communication((unsigned char)(data));
}

/******************************************************************************
* Function Name  : GetTouchADC
* Description    : ȡ1XPT2046ȡ1ADC
* Input          : XPT2046ֽ.
                    ֻµĴ:
                    CMD_READ_X:ȡXADCֵ                
                    CMD_READ_Y:ȡYADCֵ
* Output         : None
* Return         : ADתĽ.
******************************************************************************/
unsigned int GetTouchADC (unsigned char data)
{	  
	unsigned int NUMH , NUML;
	unsigned int Num;
	LCD_CS_H();
	TOUCH_nCS_L();
		
	//delay_10us(1);
	SPI0_communication(data);
	//delay_10us(1);             // ʱȴת
	NUMH=SPI0_communication(0x00);
	NUML=SPI0_communication(0x00);
	Num=((NUMH)<<8)+NUML; 	
	Num>>=4;                // ֻи12λЧ.
	TOUCH_nCS_H();

	return(Num);   
}


#define READ_TIMES 10 //ȡ
#define LOST_VAL 4	  //ֵ

/*************************************************
     ܣ  ȡXPT2046,ȡADC, READ_TIMES .
             һȣԷֵɸѡ.
 ڲcmd_code:XPT2046Ŀֽ.
            ֻµĴ:
            CMD_READ_X:ȡXADCֵ                
            CMD_READ_Y:ȡYADCֵ
*************************************************/

unsigned int GetTouchADCEx(unsigned char cmd_code)
{
	unsigned int i, j;
	unsigned int buf[READ_TIMES];
	unsigned int sum=0;
	unsigned int temp;

	for(i=0;i<READ_TIMES;i++)
	{				 
		buf[i]=GetTouchADC(cmd_code);	    
	}				    
	for(i=0;i<READ_TIMES-1; i++)//
	{
		for(j=i+1;j<READ_TIMES;j++)
		{
			if(buf[i]>buf[j])//
			{
				temp=buf[i];
				buf[i]=buf[j];
				buf[j]=temp;
			}
		}
	}	  
	sum=0;
	for(i=LOST_VAL;i<READ_TIMES-LOST_VAL;i++)sum+=buf[i];
	temp=sum/(READ_TIMES-2*LOST_VAL);
	return temp;   
}


/*************************************************/
/*     ܣȡXADCֵ                  */
/* ڲ&touch_dot.x_ad_val,&touch_dot.y_ad_val   */
/* ڲ0ɹصX,Y_ADCֵЧ      */
/*           1: ʧܣصX,Y_ADCֵЧ      */ 
/*************************************************/
unsigned char Read_ADS(unsigned int *x_ad,unsigned int *y_ad)
{
	unsigned int xtemp,ytemp;			 	 		  
	xtemp=GetTouchADCEx(CMD_READ_X);    //ɸѡĶȡXADת
	ytemp=GetTouchADCEx(CMD_READ_Y);	    //ɸѡĶȡYADת											   
	if(xtemp<100||ytemp<100)
        return 1;   //ʧ
	*x_ad=xtemp;
	*y_ad=ytemp;        
	return 0;//ɹ
}

/*************************************************/
/* ܣζȡADCֵ						 */
/* ԭζȡֵȽϣΧڿȡ  */ 
/* ڲx:&touch_dot.x_ad_val(XADCֵ)      */
/*           y:&touch_dot.y_ad_val(YADCֵ)      */
/* ڲ0ɹصX,Y_ADCֵЧ      */
/*           1: ʧܣصX,Y_ADCֵЧ      */ 
/*************************************************/
#define ERR_RANGE 50 //Χ 

unsigned char Read_ADS2(unsigned long *x_ad,unsigned long *y_ad) 
{
	unsigned int x1,y1;
 	unsigned int x2,y2;
 	unsigned char res; 

    res=Read_ADS(&x1,&y1);  // һζȡADCֵ 
    if(res==1)  return(1);	// ʧܣ1
    res=Read_ADS(&x2,&y2);	// ڶζȡADCֵ   
    if(res==1)  return(1);   	// ʧܣ1
    if(((x2<=x1&&x1<x2+ERR_RANGE)||(x1<=x2&&x2<x1+ERR_RANGE))//ǰβ+-50
        &&((y2<=y1&&y1<y2+ERR_RANGE)||(y1<=y2&&y2<y1+ERR_RANGE)))
    {
        *x_ad=(x1+x2)/2;
        *y_ad=(y1+y2)/2;
        return 0;	 // ȷȡ0
    }
    else return 1;	 // ǰ+-50ڣ 
} 

/*************************************************/
/* ܣѶADCֵתֵ               */
/*************************************************/	  
void convert_ad_to_xy(void)
{
	touch_dot.x=((touch_dot.x_ad_val-90)/5.500); // ѶX_ADCֵתTFT Xֵ
	touch_dot.y=((touch_dot.y_ad_val-115)/4.205); // ѶY_ADCֵתTFT Yֵ//    touch_dot.x = (((touch_dot.x_ad_val * 240)>>12)-110)*2;
}
 
/*************************************************/
/* ܣȡһXYֵ                        */
/*************************************************/	
unsigned char Read_Once(void)
{
//	touch_dot.pen_status=Pen_Up;
	if(Read_ADS2(&touch_dot.x_ad_val,&touch_dot.y_ad_val)==0)	// ȡݳɹ
	{
		while((GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_1))==0);   // ǲǻ:IRQΪ͵ƽ(bit7Ϊ0)˵
		convert_ad_to_xy();   // ѶADCֵתTFTֵ
		return 0;	// 0ʾɹ
	}
	else return 1;	// ȡʧܣ1ʾʧ
}
/*************************************************/
/* ܣȡXYֵ                        */
/*************************************************/
unsigned char Read_Continue(void)
{
//	touch_dot.pen_status=Pen_Up;	  
	if(Read_ADS2( &touch_dot.x_ad_val,&touch_dot.y_ad_val )==0)	 // ȡݳɹ
	{
		convert_ad_to_xy();   // ѶADCֵתTFTֵ
		return 0;	   // 0ʾɹ
	}
	else return 1;	   // ȡʧܣ1ʾʧ
}










