#include "stm32f10x.h"
#include "ucos_ii.h"
#include "LedAndKey.h"
#include "LTM022A69B.h"
#include "Touch.h"
#include "LedAndKey.h"

//궨
#define OS_MINI_STACK_SIZE 128
#define TASK_UART_PRIO 5
#define TASK_LCD_PRIO 6

//ջ
static  OS_STK TaskStartStk[OS_MINI_STACK_SIZE];
static  OS_STK TaskLcdStk[OS_MINI_STACK_SIZE];

void RCC_Config(void)
{
	ErrorStatus HSEStartUpStatus;//ⲿپ״̬öٱ
	
	RCC_DeInit();//λRCCⲿ豸ĴĬֵ
	RCC_HSEConfig(RCC_HSE_ON); //ⲿپ
	HSEStartUpStatus = RCC_WaitForHSEStartUp();//ȴⲿʱ׼
	if(HSEStartUpStatus == SUCCESS)//ⲿʱѾ׼
  		{
			RCC_HCLKConfig(RCC_SYSCLK_Div1);//AHB(HCLK)ʱӵ==SYSCLK
			RCC_PCLK2Config(RCC_HCLK_Div1); //APB2(PCLK2)==AHBʱ
			RCC_PCLK1Config(RCC_HCLK_Div2);//APB1(PCLK1)==AHB1/2ʱ			
		    FLASH_SetLatency(FLASH_Latency_2);//FLASHʱ2
		    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);//ʹFLASHԤȡ
			RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);	//PLLʱ == 8M*9

		    RCC_PLLCmd(ENABLE);//ʹPLLʱ
			while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET); //ȴPLLʱӾ

		    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);//ϵͳʱ = PLLʱ
		
		    while(RCC_GetSYSCLKSource() != 0x08); //PLLʱǷΪϵͳʱ
		}
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);//GPIODAFIOʱ
}

static void TaskUart(void* p_arg)
{
   
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOB , ENABLE);
  GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable,ENABLE);
	
	LedGpioConfiguration();

	while(1)
	{
		GPIO_WriteBit( IO_LED_ARRAY, IO_LED1 | IO_LED2 | IO_LED3 | IO_LED4,Bit_SET);
		OSTimeDly(50);
		GPIO_WriteBit( IO_LED_ARRAY, IO_LED1 | IO_LED2 | IO_LED3 | IO_LED4,Bit_RESET);
		OSTimeDly(50);
	}
}

static  void TaskLcd(void* p_arg)
{
	uint8_t i;
	lcd_init();
	lcd_init();

	while(1)
	{
		for(i=5;i<15;i++)
		{
			lcd_display_string( "  *www.WaveShare.net*  ", BLACK, GREEN, 3, i );
			OSTimeDly(100);
		}
		
		for(i=5;i<15;i++)
		{
			lcd_display_string( "  *****UCOS TEST*****  ", BLACK, RED, 3, i );
			OSTimeDly(100);
		}
	}
}

int main(void)
{     
	RCC_Config();

	SysTick_Config((uint32_t)9000);
	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);

	OSInit(); //Initialize "uC/OS-II, The Real-Time Kernel".    
	
   /* Create the start task.                               */
  OSTaskCreate((void (*) (void *)) TaskUart,
               (void *) 0,
               (OS_STK *) &TaskStartStk[OS_MINI_STACK_SIZE - 1],
               (INT8U) TASK_UART_PRIO);

   /* Create the lcd task.                               */
   OSTaskCreate((void (*) (void *)) TaskLcd,
               (void *) 0,
               (OS_STK *) &TaskLcdStk[OS_MINI_STACK_SIZE - 1],
               (INT8U) TASK_LCD_PRIO);

	OSTimeSet(0);
	OSStart();  //Start multitasking (i.e. give control to uC/OS-II).  

	return (0);
}



//ϵͳӣ
#if (OS_APP_HOOKS_EN > 0)
void App_TaskCreateHook(OS_TCB* ptcb)
{
}

void App_TaskDelHook(OS_TCB* ptcb)
{
   (void) ptcb;
}

void App_TaskIdleHook(void)
{
}

void App_TaskStatHook(void)
{
}

#if OS_TASK_SW_HOOK_EN > 0
void App_TaskSwHook(void)
{
}
#endif

void App_TCBInitHook(OS_TCB* ptcb)
{
   (void) ptcb;
}

#endif
